Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bag
Class UnmodifiableSortedBag

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.bag.AbstractBagDecorator
              org.apache.commons.collections.bag.AbstractSortedBagDecorator
                  org.apache.commons.collections.bag.UnmodifiableSortedBag

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, Bag, SortedBag, Unmodifiable

    public final class UnmodifiableSortedBag

extends AbstractSortedBagDecorator
implements Unmodifiable, java.io.Serializable

Decorates another `SortedBag` to ensure it can't be altered.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Method Summary
`boolean` | `add(java.lang.Object object)` (Violation) Adds one copy the specified object to the Bag.
`boolean` | `add(java.lang.Object object, int count)` Adds `nCopies` copies of the specified object to the Bag.
`boolean` | `addAll(java.util.Collection coll)`
`void` | `clear()`
`static SortedBag` | `decorate(SortedBag bag)` Factory method to create an unmodifiable bag.
`java.util.Iterator` | `iterator()` Returns an `Iterator` over the entire set of members, including copies due to cardinality.
`boolean` | `remove(java.lang.Object object)` (Violation) Removes all occurrences of the given object from the bag.
`boolean` | `remove(java.lang.Object object, int count)` Removes `nCopies` copies of the specified object from the Bag.
`boolean` | `removeAll(java.util.Collection coll)` (Violation) Remove all elements represented in the given collection, respecting cardinality.
`boolean` | `retainAll(java.util.Collection coll)` (Violation) Remove any members of the bag that are not in the given collection, respecting cardinality.
`java.util.Set` | `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from class org.apache.commons.collections.bag.AbstractSortedBagDecorator
`comparator, first, getSortedBag, last`

Methods inherited from class org.apache.commons.collections.bag.AbstractBagDecorator
`getBag, getCount`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`contains, containsAll, equals, getCollection, hashCode, isEmpty, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`containsAll, getCount, size`

Methods inherited from interface java.util.Collection
`contains, equals, hashCode, isEmpty, toArray, toArray`

Method Detail

### decorate

    public static SortedBag decorate(SortedBag bag)

  Factory method to create an unmodifiable bag.

  If the bag passed in is already unmodifiable, it is returned.

  Parameters:
    `bag` - the bag to decorate, must not be null
  Returns:
    an unmodifiable SortedBag
  Throws:
    `java.lang.IllegalArgumentException` - if bag is null

### iterator

    public java.util.Iterator iterator()

  Description copied from interface: `Bag`
  Returns an `Iterator` over the entire set of members, including copies due to cardinality. This iterator is fail-fast and will not tolerate concurrent modifications.

  Specified by:
    `iterator` in interface `java.lang.Iterable`
  Specified by:
    `iterator` in interface `java.util.Collection`
  Specified by:
    `iterator` in interface `Bag`
  Overrides:
    `iterator` in class `AbstractCollectionDecorator`
  Returns:
    iterator over all elements in the Bag

### add

    public boolean add(java.lang.Object object)

  Description copied from interface: `Bag`
  (Violation) Adds one copy the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as 1.

  Since this method always increases the size of the bag, according to the `Collection.add(Object)` contract, it should always return `true`. Since it sometimes returns `false`, this method violates the contract.

  Specified by:
    `add` in interface `java.util.Collection`
  Specified by:
    `add` in interface `Bag`
  Overrides:
    `add` in class `AbstractCollectionDecorator`
  Parameters:
    `object` - the object to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### addAll

    public boolean addAll(java.util.Collection coll)

  Specified by:
    `addAll` in interface `java.util.Collection`
  Overrides:
    `addAll` in class `AbstractCollectionDecorator`

### clear

    public void clear()

  Specified by:
    `clear` in interface `java.util.Collection`
  Overrides:
    `clear` in class `AbstractCollectionDecorator`

### remove

    public boolean remove(java.lang.Object object)

  Description copied from interface: `Bag`
  (Violation) Removes all occurrences of the given object from the bag.

  This will also remove the object from the `Bag.uniqueSet()`.

  According to the `Collection.remove(Object)` method, this method should only remove the first occurrence of the given object, not all occurrences.

  Specified by:
    `remove` in interface `java.util.Collection`
  Specified by:
    `remove` in interface `Bag`
  Overrides:
    `remove` in class `AbstractCollectionDecorator`
  Returns:
    `true` if this call changed the collection

### removeAll

    public boolean removeAll(java.util.Collection coll)

  Description copied from interface: `Bag`
  (Violation) Remove all elements represented in the given collection, respecting cardinality. That is, if the given collection `coll` contains `n` copies of a given object, the bag will have `n` fewer copies, assuming the bag had at least `n` copies to begin with.

  The `Collection.removeAll(Collection)` method specifies that cardinality should not be respected; this method should remove all occurrences of every object contained in the given collection.

  Specified by:
    `removeAll` in interface `java.util.Collection`
  Specified by:
    `removeAll` in interface `Bag`
  Overrides:
    `removeAll` in class `AbstractCollectionDecorator`
  Parameters:
    `coll` - the collection to remove
  Returns:
    `true` if this call changed the collection

### retainAll

    public boolean retainAll(java.util.Collection coll)

  Description copied from interface: `Bag`
  (Violation) Remove any members of the bag that are not in the given collection, respecting cardinality. That is, if the given collection `coll` contains `n` copies of a given object and the bag has `m > n` copies, then delete `m - n` copies from the bag. In addition, if `e` is an object in the bag but `!coll.contains(e)`, then remove `e` and any of its copies.

  The `Collection.retainAll(Collection)` method specifies that cardinality should not be respected; this method should keep all occurrences of every object contained in the given collection.

  Specified by:
    `retainAll` in interface `java.util.Collection`
  Specified by:
    `retainAll` in interface `Bag`
  Overrides:
    `retainAll` in class `AbstractCollectionDecorator`
  Parameters:
    `coll` - the collection to retain
  Returns:
    `true` if this call changed the collection

### add

    public boolean add(java.lang.Object object,
                       int count)

  Description copied from interface: `Bag`
  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

  Specified by:
    `add` in interface `Bag`
  Overrides:
    `add` in class `AbstractBagDecorator`
  Parameters:
    `object` - the object to add
    `count` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### remove

    public boolean remove(java.lang.Object object,
                          int count)

  Description copied from interface: `Bag`
  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Specified by:
    `remove` in interface `Bag`
  Overrides:
    `remove` in class `AbstractBagDecorator`
  Parameters:
    `object` - the object to remove
    `count` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### uniqueSet

    public java.util.Set uniqueSet()

  Description copied from interface: `Bag`
  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Specified by:
    `uniqueSet` in interface `Bag`
  Overrides:
    `uniqueSet` in class `AbstractBagDecorator`
  Returns:
    the Set of unique Bag elements

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.